#include "plot.h"

const QPointF Plot::zero(0, 0);


Plot::Plot(QObject *parent)
    : QGraphicsScene(parent)
{
}

void Plot::setXAxis(qreal min, qreal max, qreal step)
{
    addLine(QLineF(zero, QPointF(max - min, 0)));
    if (!step) return;

    QLineF tick(QPointF(0, 0), QPointF(0, 4));
    addLine(tick);

    for (qreal i = 0; i < max - min; i+= step) {
	tick.translate(step, 0);
	addLine(tick);
    }

}

void Plot::setYAxis(qreal min, qreal max, qreal step)
{
    addLine(QLineF(zero, QPointF(0, -1 * (max - min))));
    if (!step) return;
}

void Plot::draw(QList< QPair<QTime, int> >::const_iterator current,
    QList< QPair<QTime, int> >::const_iterator end)
{
    QTime t0 = current->first;
    int offset = current->second;

    QPolygonF poly;
    QPainterPath path;

    while (current != end) {
	QPoint p(t0.secsTo(current->first), -1 * (current->second - offset));
	path.lineTo(p);
	++current;
    }

    addPath(path);
}
